/*  allest.cpp

*/

#include "allest.hpp"

TEstimator *HillGP1, *MEGP1, *MLEGP, *MomentGP, *DreesPickandsGP, *SlopeGP,
	   *MLEEV1, *MLEEV, *RDEEV, *MDEEV, *MDEGroupedEV,
	   *MLEGaussian, *MHDEGaussian, *MDEGaussian, *MLECen, *HillCen, *MLET, *MLENCT,
	   *LSEGaussian, *MLEGumbel, *MLEExponential, *BayesEstPareto,
           *QuickGaussian, *MLEStable, *KKWStable, *LMomentGP;

void BuildEstimators () {
    MLEExponential =    new TExponentialEstimator (TRUE);
    HillGP1 = 		new THillEstimator (TRUE);
#ifndef TERMINAL
    BayesEstPareto =	new TExtParetoBayesEstimator (TRUE);
    MEGP1 = 		new TMEstimator (TRUE);
#endif    
    MLEEV = 		new TEVDMLEstimator (TRUE);
    MLEEV1 = 		new TFrechetMLEstimator (TRUE);
    MLEGumbel = 	new TGumbelMLEstimator (TRUE);
    RDEEV = 		new TDiffRatioEstimator (TRUE);
    MLEGaussian = 	new TNormalMLEstimator (TRUE);
    LSEGaussian =	new TNormalLSEstimator (TRUE);
    QuickGaussian =     new TNormalQuickEstimator (TRUE);
    MomentGP =  	new TMomentEstimator (TRUE);
    LMomentGP = 	new TLMomentGPEstimator (TRUE);
    DreesPickandsGP = 	new TDreesPickandsEstimator (TRUE);
    SlopeGP =		new TSlopeEstimator (TRUE);
    MLEGP = 		new TMLEEstimator (TRUE);
    MLET = 		new TTMLEstimator (TRUE);
    MLENCT = 		new TNCTMLEstimator (TRUE);
#ifdef TERMINAL
    MDEEV =		new TEVDMDEstimator ();
#else
    MDEEV =		new TEVDMDEstimator ("MDE (EV)", IDM_MDEEV, IDD_EVDEstimator, TRUE);
#endif
#ifdef USE_STABLE
    MLEStable = 	new TStableMLEstimator (TRUE);
    KKWStable = 	new TStableKKWEstimator (TRUE);
#endif
#ifndef TERMINAL
    MDEGroupedEV =      new TGroupedEVDMDEstimator (TRUE);
    MDEGaussian = 	new TNormalMDEstimator ("MDE (Gaussian)",  IDM_MDEGauss,  IDD_GaussEstimator, TRUE);
    MHDEGaussian = 	new TNormalMHDEstimator ("MHDE (Gaussian)",  IDM_MHDEGauss,  IDD_GaussEstimator, TRUE);
			new TGroupedNormalMDEstimator (TRUE);
			new TGroupedNormalMHDEstimator (TRUE);
			new TGroupedMLEstimator (TRUE);
                        new TGroupedGPMLEstimator (TRUE);
			new TPoissonEstimator (TRUE);
                        new TPoissonBayesEstimator (TRUE);
			new TNegativeBinomialMLEstimator (TRUE);
			new TNegativeBinomialMomentEstimator (TRUE);
    HillCen =		new THillCenEstimator (TRUE);
    MLECen = 		new TMLECenEstimator (TRUE);
#endif
}
