/* debug
  ~~~~~~~
  $Id: debug.hpp,v 1.24 2001/02/12 22:16:03 michael Exp $

  Description:
  a collection of macros to give some help when debugging weird program
  behaviour...

  set the #define DEBUG_FLOOD to get the messages, and unset it to make
  the debugging macros no op's.
  (Beware of Heissen bugs....)

  Todo:

  Bugs:

  created: 1999-08-26 Reinhard Pfau <Reinhard.Pfau@unix-ag.org>
  modified:

*/

#ifndef _DEBUG_HPP_
#define _DEBUG_HPP_

#include <typeinfo>
#include <iostream>
#include <iomanip>


#ifdef DEBUG_FLOOD

#define CERR(x) std::cerr << x << std::endl
#define FCERR(x) std::cerr << __PRETTY_FUNCTION__ << ": " << x << std::endl
#define MCERR(x) std::cerr << "(" << this << ") " << __PRETTY_FUNCTION__ \
  << ": " << x << std::endl

#else

#define CERR(x)
#define FCERR(x)
#define MCERR(x)

#endif


#define UNIMPLEMENTED() FCERR(" not implemented")


#endif
