/*  refcount.hpp

    Generic class supporting reference counting and automatic deletion.

    This file is part of Xtremes for Windows,
    Copyright (C) 1991, 2000 Xtremes Group, Siegen.
*/

#ifndef REFC_HPP
#define REFC_HPP

#include <stdlib.h>

class TDataObject {
    public:
	TDataObject ();
	virtual ~TDataObject ();
	virtual TDataObject *Duplicate ();
	int RefCount;
};

class TDataRefHandler {
    public:
	TDataRefHandler ();
	virtual ~TDataRefHandler ();
	TDataRefHandler (TDataObject *);
	TDataRefHandler (const TDataRefHandler &);
	void operator = (TDataRefHandler);
	TDataObject *GetDataObject ();
    private:
	TDataObject *RefObject;
};

class TDataFrame {
    public:
	TDataFrame (TDataObject *p = NULL);
//        TDataFrame (const TDataFrame &);
	TDataObject *GetDataObject ();
	void MakeUnique ();
        void operator = (TDataFrame f);
    private:
	TDataRefHandler RefHandler;
};

#endif

