/*  samplist.hpp

    List of loaded samples.

    This file is part of Xtremes for Windows,
    Copyright (C) 1996 Xtremes Group, Siegen.
*/

#ifndef SAMPLIST_HPP
#define SAMPLIST_HPP

#include "sampbase.hpp"

#ifndef TERMINAL
#include "listdlg.hpp"
#endif

#ifndef TERMINAL
class TSampleList : public TList, public TDialog {
    typedef TDialog inherited;
#else
class TSampleList : public TList {
#endif
    public:
#ifndef TERMINAL
	TSampleList ();
#endif
	virtual ~TSampleList ();
#ifdef TERMINAL
	TSample *GetActiveSample ();
#else
	TSample *GetActiveSample (TWindow *parent);
#endif
	BOOL LoadSample (String fn);
	void InsertSample (TSample *);
#ifndef TERMINAL
	BOOL LoadSample (TWindow *parent);
	void ChooseActiveSample (TWindow *parent);	// hwndParent should be main window (i.e. MDIFrame)
	BOOL CheckActiveSample (TWindow *parent, TSampleType Required);
#endif
    protected:
#ifndef TERMINAL
	virtual void NotifyActionEvent (TDialogMember *m);
        virtual void NotifyInitDialog ();
#endif
    private:
#ifndef TERMINAL
	BOOL DeleteDuplicates ();
	void ChangeLists ();		// updates list in dialog and disables buttons
	TListField Samples, Description;
	TButton DeleteButton;
	TList SampleCopy;		// temporary copy for editing
	BOOL Deleted;			// set true iff dialog deleted some samples
#endif
};

extern TSampleList SampleList;

#endif
