/*  stddef.cpp

    Deklarationen haeufig benoetiger Funktionen
*/

#include "stddef.hpp"
#include <math.h>
#include <float.h>

// Comparison function for quicksort

int _USERENTRY realcomp (const void *a, const void *b) {
    double fa = * (double *) a,
           fb = * (double *) b;
    if (fa < fb) return - 1;
    if (fa > fb) return 1;
    return 0;
}

// Parser

// wer braucht das eigentlich und wer nicht?
#include <ctype.h>

BOOL ParseReal (const char *fpos, double &value) {
    long double z = 0.0, d = 1.0;
    int s = 0, e = 0;
    BOOL negative = FALSE;
    if (!strcmp (fpos, "infty"))  { value = MYMAXDOUBLE; return TRUE; }
    if (!strcmp (fpos, "-infty")) { value = -MYMAXDOUBLE; return TRUE; }
    while (*fpos == ' ') fpos++;
    if (*fpos == '-') {
	negative = TRUE;
	fpos++;
    }
    while (isdigit (*fpos)) z = z * 10.0 + *fpos++ - '0';
    if (*fpos == '.') {
	fpos++;
	while (isdigit (*fpos))
	    z = z + (d /= 10.0) * (*fpos++ - '0');
    }
    if (*fpos == 'e' || *fpos == 'E') {
	fpos++;
	if (*fpos == '+' || *fpos == '-') s = *fpos++ == '-';
	while (isdigit (*fpos)) e = e * 10 + *fpos++ - '0';
	if (s) e = -e;
    }

    if (e > 1000) return FALSE;
    z *= pow (10, e);
    if (z < -DBL_MAX || z > DBL_MAX) return FALSE;
    value = negative ? -z : z;
    return !*fpos;
}

