/*  string.hpp

    Declaration of string class.

    This file is part of Xtremes for Windows,
    Copyright (C) 1994 Xtremes Group, Siegen.
*/

#ifndef STRING_HPP
#define STRING_HPP

#include <string.h>
#include <stdio.h>

#include "boolean.hpp"

class String {
    public:
	String (const char *s= "", BOOL MakeCopy = TRUE);
	String (const String &);
	String (const char c);
	~String ();

	String operator = (const String);
	String operator () (int pos, int len);

	operator const char * () const                { return p->s; }
	int Len () const;

	friend String operator & (const String, const String);

	friend BOOL operator < (const String, const String);
	friend BOOL operator > (const String, const String);
	friend BOOL operator == (const String, const String);
	friend BOOL operator != (const String, const String);
	friend BOOL operator <= (const String, const String);
	friend BOOL operator >= (const String, const String);
    private:
	class StringData {
	    public:
		const char *s;
		int RefCount, Len;
		StringData () { RefCount = 0; s = NULL; }
		~StringData ();
	};
        StringData *p;
        void DecRefCount ();
};

String form (int MaxLen, const char *fmt, ...);

char *mystrdup (const char *s);

void StringToFile (FILE *f, String s);
String StringFromFile (FILE *f);

#endif
