/*  matrix.hpp

    Implementation of matrix operations.

    This file is part of Xtremes for Windows,
    Copyright (C) 1991, 2002 Xtremes Group, Siegen.
*/

#ifndef MATRIX_HPP
#define MATRIX_HPP

#include "refc.hpp"

#include <iostream>

class TMatrix {
    public:
	TMatrix ();
	TMatrix (int n, int m);
	TMatrix (int n, int m, double *a);
	TMatrix (const TMatrix &);
	~TMatrix ();

	TMatrix & operator = (const TMatrix & A);

	int Rows (), Columns ();
	double & operator () (int l, int c);
	friend TMatrix operator + (TMatrix, TMatrix);
	friend TMatrix operator - (TMatrix, TMatrix);
	friend TMatrix operator * (double, TMatrix);
	friend TMatrix operator * (TMatrix, TMatrix);
	friend TMatrix operator ~ (TMatrix);		// transponiert

	friend double maxNorm (TMatrix);		// max. Zeilensumme
   	friend std::ostream & operator << (std::ostream &, TMatrix);
   private:
	double *p;
	int n, m;
};

TMatrix inv (TMatrix);
TMatrix invert(TMatrix);
TMatrix sqrt (TMatrix);
double det(TMatrix);
TMatrix chol(TMatrix);

#endif
